import { BeforeErrorPipeline, AsyncActionCreatorsMapObject } from 'src/typings';
import { SerializableResponse } from '../helpers/fetch';
import { AsyncActionCreator, FetchOptions, ReduceOptions } from '../typings';
import { AnyTransform } from './transform';
export declare const SUPPORTED_FETCH_OPTS: readonly ["url", "method", "headers", "credentials", "query", "body", "signal"];
export declare const SUPPORTED_REDUCE_OPTS: readonly ["assignResponse", "gerundName", "invalidateState", "isArray", "isPure", "mergeResponse", "params", "reduce"];
declare type GetActionNameOptions = {
    resourceName: string;
    resourcePluralName?: string;
    isArray?: boolean;
    alias?: string;
};
declare const getActionName: (actionId: string, { resourceName, resourcePluralName, isArray, alias }: GetActionNameOptions) => string;
export declare type CreateActionOptions = FetchOptions & ReduceOptions & {
    scope?: string;
    stripTrailingSlashes?: boolean;
    transformResponse?: AnyTransform<SerializableResponse>;
    beforeError?: BeforeErrorPipeline;
    alias?: string;
};
declare const createAction: (actionId: string, { scope, stripTrailingSlashes, ...actionOpts }: CreateActionOptions) => AsyncActionCreator;
declare type CreateActionsOptions = {
    resourceName: string;
    resourcePluralName?: string;
    scope?: string;
    stripTrailingSlashes?: boolean;
    transformResponse?: AnyTransform<SerializableResponse>;
    beforeError?: BeforeErrorPipeline;
} & FetchOptions & ReduceOptions;
declare const createActions: (actions: Record<string, import("../typings").ConfigActionOptions> | undefined, { resourceName, resourcePluralName, scope, ...globalOpts }: CreateActionsOptions) => AsyncActionCreatorsMapObject;
export { getActionName, createAction, createActions };
