"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.applyTransformPipeline = exports.buildTransformPipeline = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _defaults = require("../defaults");

var buildTransformPipeline = function buildTransformPipeline(initial, transform) {
  var transformResponsePipeline;

  if (transform) {
    transformResponsePipeline = Array.isArray(transform) ? transform : [].concat((0, _toConsumableArray2["default"])(initial), [transform]);
  } else {
    transformResponsePipeline = (0, _toConsumableArray2["default"])(initial);
  }

  return transformResponsePipeline;
};

exports.buildTransformPipeline = buildTransformPipeline;

var applyTransformPipeline = function applyTransformPipeline(pipeline) {
  return function (initial) {
    return pipeline.reduce(function (soFar, fn) {
      return soFar.then(fn);
    }, _defaults.defaultGlobals.Promise.resolve(initial));
  };
};

exports.applyTransformPipeline = applyTransformPipeline;
//# sourceMappingURL=transform.js.map