"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.initialState = exports.defaultState = exports.defaultIdKeys = exports.defaultHeaders = exports.defaultActions = exports.defaultGlobals = exports.defaultMergeItem = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var defaultActions = {
  create: {
    method: 'POST',
    assignResponse: true
  },
  fetch: {
    method: 'GET',
    isArray: true
  },
  get: {
    method: 'GET'
  },
  update: {
    method: 'PATCH'
  },
  updateMany: {
    method: 'PATCH',
    isArray: true,
    alias: 'update'
  },
  "delete": {
    method: 'DELETE'
  },
  deleteMany: {
    method: 'DELETE',
    isArray: true,
    alias: 'delete'
  }
};
exports.defaultActions = defaultActions;
var defaultHeaders = {
  Accept: 'application/json',
  'Content-Type': 'application/json'
};
exports.defaultHeaders = defaultHeaders;
var defaultIdKeys = {
  singular: 'id',
  plural: 'ids'
};
exports.defaultIdKeys = defaultIdKeys;
var defaultState = {
  create: {
    isCreating: false
  },
  fetch: {
    items: [],
    isFetching: false,
    lastUpdated: 0,
    didInvalidate: true
  },
  get: {
    item: null,
    isFetchingItem: false,
    lastUpdatedItem: 0,
    didInvalidateItem: true
  },
  update: {
    isUpdating: false
  },
  "delete": {
    isDeleting: false
  }
};
exports.defaultState = defaultState;
var initialState = Object.keys(defaultState).reduce(function (soFar, key) {
  return _objectSpread(_objectSpread({}, soFar), defaultState[key]);
}, {});
exports.initialState = initialState;

var defaultMergeItem = function defaultMergeItem(prevItem, nextItem) {
  return Object.assign(prevItem || {}, nextItem);
};

exports.defaultMergeItem = defaultMergeItem;
var defaultGlobals = {
  Promise: Promise,
  fetch: fetch
};
exports.defaultGlobals = defaultGlobals;
//# sourceMappingURL=index.js.map