"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.serializeResponse = exports.parseResponseBody = exports.buildFetchOpts = exports.buildFetchUrl = exports.HttpError = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _wrapNativeSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/wrapNativeSuper"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _defaults = require("../defaults");

var _url = require("./url");

var _util = require("./util");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var HttpError = /*#__PURE__*/function (_Error) {
  (0, _inherits2["default"])(HttpError, _Error);

  var _super = _createSuper(HttpError);

  function HttpError() {
    var _this;

    var statusCode = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 500;

    var _ref = arguments.length > 1 ? arguments[1] : undefined,
        body = _ref.body,
        _ref$message = _ref.message,
        message = _ref$message === void 0 ? 'HttpError' : _ref$message,
        headers = _ref.headers;

    (0, _classCallCheck2["default"])(this, HttpError);
    _this = _super.call(this, message);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "statusCode", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "status", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "body", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "headers", {});
    _this.name = _this.constructor.name;
    _this.message = message;

    if (typeof Error.captureStackTrace === 'function') {
      Error.captureStackTrace((0, _assertThisInitialized2["default"])(_this), _this.constructor);
    } else {
      _this.stack = new Error(message).stack;
    } // Http


    _this.statusCode = statusCode;
    _this.status = statusCode;
    _this.body = body;

    if (headers) {
      _this.headers = Object.fromEntries(headers.entries());
    }

    return _this;
  }

  return HttpError;
}( /*#__PURE__*/(0, _wrapNativeSuper2["default"])(Error));

exports.HttpError = HttpError;

var buildFetchUrl = function buildFetchUrl(context, _ref2) {
  var url = _ref2.url,
      _ref2$method = _ref2.method,
      method = _ref2$method === void 0 ? 'get' : _ref2$method,
      urlParams = _ref2.urlParams,
      _ref2$params = _ref2.params,
      params = _ref2$params === void 0 ? {} : _ref2$params,
      _ref2$isArray = _ref2.isArray,
      isArray = _ref2$isArray === void 0 ? false : _ref2$isArray,
      _ref2$stripTrailingSl = _ref2.stripTrailingSlashes,
      stripTrailingSlashes = _ref2$stripTrailingSl === void 0 ? true : _ref2$stripTrailingSl;

  var _splitUrlByProtocolAn = (0, _url.splitUrlByProtocolAndDomain)(url),
      _splitUrlByProtocolAn2 = (0, _slicedToArray2["default"])(_splitUrlByProtocolAn, 2),
      _splitUrlByProtocolAn3 = _splitUrlByProtocolAn2[0],
      protocolAndDomain = _splitUrlByProtocolAn3 === void 0 ? '' : _splitUrlByProtocolAn3,
      remainderUrl = _splitUrlByProtocolAn2[1];

  var contextAsObject = !(0, _util.isObject)(context) ? (0, _defineProperty2["default"])({}, _defaults.defaultIdKeys.singular, context) : context; // Replace urlParams with values from context

  var builtUrl = Object.keys(urlParams).reduce(function (wipUrl, urlParam) {
    var urlParamInfo = urlParams[urlParam];
    var value = params[urlParam] || contextAsObject[urlParam] || ''; // self.defaults[urlParam];

    if (value) {
      var encodedValue = urlParamInfo.isQueryParamValue ? (0, _url.encodeUriQuery)((0, _util.toString)(value), true) : (0, _url.encodeUriSegment)((0, _util.toString)(value));
      return (0, _url.replaceUrlParamFromUrl)(wipUrl, urlParam, encodedValue);
    } else if (!isArray && urlParam === _defaults.defaultIdKeys.singular && !['post'].includes(method.toLowerCase())) {
      throw new Error("Failed to resolve required \"".concat(urlParam, "\" from context=").concat(JSON.stringify(context)));
    }

    return (0, _url.replaceUrlParamFromUrl)(wipUrl, urlParam);
  }, remainderUrl); // Strip trailing slashes and set the url (unless this behavior is specifically disabled)

  if (stripTrailingSlashes) {
    builtUrl = builtUrl.replace(/\/+$/, '') || '/';
  }

  return protocolAndDomain + builtUrl;
};

exports.buildFetchUrl = buildFetchUrl;

var buildFetchOpts = function buildFetchOpts(context, _ref4) {
  var method = _ref4.method,
      headers = _ref4.headers,
      credentials = _ref4.credentials,
      query = _ref4.query,
      body = _ref4.body;
  var opts = {
    method: 'GET',
    headers: _defaults.defaultHeaders
  };

  if (method) {
    opts.method = method;
  }

  if (headers) {
    opts.headers = _objectSpread(_objectSpread({}, opts.headers), headers);
  }

  if (credentials) {
    opts.credentials = credentials;
  }

  if (query) {
    opts.query = query;
  }

  var hasBody = /^(POST|PUT|PATCH|DELETE)$/i.test(opts.method);

  if (body) {
    opts.body = (0, _util.isString)(body) ? body : JSON.stringify(body);
  } else if (hasBody && context) {
    var contextAsObject = !(0, _util.isObject)(context) ? (0, _defineProperty2["default"])({}, _defaults.defaultIdKeys.singular, context) : context;
    opts.body = JSON.stringify(contextAsObject);
  }

  return opts;
};

exports.buildFetchOpts = buildFetchOpts;

var parseResponseBody = function parseResponseBody(res) {
  var contentType = res.headers.get('Content-Type'); // @NOTE parses 'application/problem+json; charset=utf-8' for example
  // see https://tools.ietf.org/html/rfc6839

  var isJson = contentType && ((0, _util.startsWith)(contentType, 'application/json') || (0, _util.endsWith)(contentType.split(';')[0], '+json'));
  return res[isJson ? 'json' : 'text']();
};

exports.parseResponseBody = parseResponseBody;

var serializeResponse = /*#__PURE__*/function () {
  var _ref6 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(res) {
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return parseResponseBody(res);

          case 2:
            _context.t0 = _context.sent;
            _context.t1 = res.status;
            _context.t2 = res.status;
            _context.t3 = Object.fromEntries(res.headers.entries());
            _context.t4 = Date.now();
            _context.t5 = res.ok;
            return _context.abrupt("return", {
              body: _context.t0,
              code: _context.t1,
              status: _context.t2,
              headers: _context.t3,
              receivedAt: _context.t4,
              ok: _context.t5
            });

          case 9:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function serializeResponse(_x) {
    return _ref6.apply(this, arguments);
  };
}();

exports.serializeResponse = serializeResponse;

var fetch = /*#__PURE__*/function () {
  var _ref7 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(url) {
    var options,
        query,
        builtUrl,
        _args3 = arguments;
    return _regenerator["default"].wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            options = _args3.length > 1 && _args3[1] !== undefined ? _args3[1] : {};
            // Support options.query
            query = (0, _util.isObject)(options.query) ? options.query : {};
            builtUrl = Object.keys(query).reduce(function (wipUrl, queryParam) {
              var queryParamValue = (0, _util.isString)(query[queryParam]) ? query[queryParam] : JSON.stringify(query[queryParam]);
              return (0, _url.replaceQueryStringParamFromUrl)(wipUrl, queryParam, queryParamValue);
            }, url);
            return _context3.abrupt("return", (options.Promise || _defaults.defaultGlobals.Promise).resolve((_defaults.defaultGlobals.fetch || fetch)(builtUrl, options)).then( /*#__PURE__*/function () {
              var _ref8 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(res) {
                var body;
                return _regenerator["default"].wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        if (res.ok) {
                          _context2.next = 5;
                          break;
                        }

                        _context2.next = 3;
                        return parseResponseBody(res);

                      case 3:
                        body = _context2.sent;
                        throw new HttpError(res.status, {
                          body: body,
                          message: res.statusText,
                          headers: res.headers
                        });

                      case 5:
                        return _context2.abrupt("return", res);

                      case 6:
                      case "end":
                        return _context2.stop();
                    }
                  }
                }, _callee2);
              }));

              return function (_x3) {
                return _ref8.apply(this, arguments);
              };
            }()));

          case 4:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));

  return function fetch(_x2) {
    return _ref7.apply(this, arguments);
  };
}();

var _default = fetch;
exports["default"] = _default;
//# sourceMappingURL=fetch.js.map