/**
 * This method is intended for encoding *key* or *value* parts of query component. We need a
 * custom method because encodeURIComponent is too aggressive and encodes stuff that doesn't
 * have to be encoded per http://tools.ietf.org/html/rfc3986
 */
export declare const encodeUriQuery: (val: string, pctEncodeSpaces: boolean) => string;
/**
 * We need our custom method because encodeURIComponent is too aggressive and doesn't follow
 * http://www.ietf.org/rfc/rfc3986.txt with regards to the character set
 * (pchar) allowed in path segments
 */
export declare const encodeUriSegment: (val: string) => string;
export declare const parseUrlParams: (url: string) => Record<string, {
    isQueryParamValue?: boolean;
}>;
export declare const replaceUrlParamFromUrl: (url: string, urlParam: string, replace?: string) => string;
export declare const replaceQueryStringParamFromUrl: (url: string, key: string, value: string) => string;
export declare const splitUrlByProtocolAndDomain: (url: string) => [string, string];
