import { Action, ContentRange } from '../typings';
export declare const includes: (array: unknown[], value: unknown) => boolean;
export declare const isString: (maybeString: unknown) => maybeString is string;
export declare const toString: (value: unknown) => string;
export declare const isObject: (maybeObject: unknown) => maybeObject is Record<string, unknown>;
export declare const isFunction: (maybeFunction: unknown) => maybeFunction is Function;
export declare const pick: <T>(obj: T, ...keys: (keyof T)[]) => Partial<T>;
export declare const find: <T extends Record<string | number | symbol, unknown>>(collection: T[], query: Partial<T>) => T | undefined;
export declare const mapObject: <T extends Record<string | number | symbol, V>, V>(object: T, func: (v: V) => V) => Record<string | number | symbol, V>;
declare type ObjectMap = Record<string, Record<string, unknown>>;
export declare const mergeObjects: (object: ObjectMap, ...sources: ObjectMap[]) => ObjectMap;
export declare const startsWith: (string: string, target: string) => boolean;
export declare const endsWith: (string: string, target: string) => boolean;
export declare const ucfirst: (string: string) => string;
export declare const upperSnakeCase: (string: string) => string;
export declare const getGerundName: (name: string) => string;
export declare const getPluralName: (name?: string) => string;
export declare const parseContentRangeHeader: (string: string) => ContentRange | null;
export declare const getIdKey: (_action: Action, { multi }: {
    multi: boolean;
}) => string;
export {};
