import { CreateActionOptions } from './actions';
import fetch, { HttpError } from './helpers/fetch';
import { ConfigActionsOptions, AsyncActionCreator, Reducer, Types, UnknownObject } from './typings';
export * from './defaults';
export { combineReducers, mergeReducers, reduceReducers } from './reducers/helpers';
export * from './typings';
export { fetch, HttpError };
export declare type CreateResourceOptions = CreateActionOptions & {
    url: string;
    name: string;
    pluralName?: string;
    actions?: ConfigActionsOptions;
    mergeDefaultActions?: boolean;
    pick?: string[];
    scope?: string;
};
export declare type Resource<T extends UnknownObject> = {
    actions: Record<string, AsyncActionCreator>;
    reducers: Reducer<T>;
    rootReducer: Reducer<T>;
    types: Types;
};
export declare function createResource<T extends UnknownObject = UnknownObject>({ url, name: resourceName, pluralName: resourcePluralName, actions: givenActions, mergeDefaultActions, pick: pickedActions, scope, ...otherOptions }: CreateResourceOptions): Resource<T>;
export declare type CreateResourceActionOptions = CreateActionOptions & {
    name: string;
    pluralName: string;
    method?: RequestInit['method'];
    isArray?: boolean;
};
export declare type ResourceAction = {
    actions: Record<string, AsyncActionCreator>;
    reducers: Record<string, Reducer>;
    rootReducer: Reducer;
    types: Record<string, string>;
};
export declare function createResourceAction({ name: resourceName, pluralName: resourcePluralName, method, isArray, ...args }: CreateResourceActionOptions): ResourceAction;
