"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  createResource: true,
  createResourceAction: true,
  fetch: true,
  HttpError: true,
  combineReducers: true,
  mergeReducers: true,
  reduceReducers: true
};
exports.createResource = createResource;
exports.createResourceAction = createResourceAction;
Object.defineProperty(exports, "fetch", {
  enumerable: true,
  get: function get() {
    return _fetch["default"];
  }
});
Object.defineProperty(exports, "HttpError", {
  enumerable: true,
  get: function get() {
    return _fetch.HttpError;
  }
});
Object.defineProperty(exports, "combineReducers", {
  enumerable: true,
  get: function get() {
    return _helpers.combineReducers;
  }
});
Object.defineProperty(exports, "mergeReducers", {
  enumerable: true,
  get: function get() {
    return _helpers.mergeReducers;
  }
});
Object.defineProperty(exports, "reduceReducers", {
  enumerable: true,
  get: function get() {
    return _helpers.reduceReducers;
  }
});

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _actions2 = require("./actions");

var _defaults = require("./defaults");

Object.keys(_defaults).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _defaults[key];
    }
  });
});

var _fetch = _interopRequireWildcard(require("./helpers/fetch"));

var _util = require("./helpers/util");

var _reducers2 = require("./reducers");

var _types = require("./types");

var _helpers = require("./reducers/helpers");

var _typings = require("./typings");

Object.keys(_typings).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _typings[key];
    }
  });
});

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function createResource(_ref) {
  var url = _ref.url,
      resourceName = _ref.name,
      _ref$pluralName = _ref.pluralName,
      resourcePluralName = _ref$pluralName === void 0 ? (0, _util.getPluralName)(resourceName) : _ref$pluralName,
      _ref$actions = _ref.actions,
      givenActions = _ref$actions === void 0 ? {} : _ref$actions,
      _ref$mergeDefaultActi = _ref.mergeDefaultActions,
      mergeDefaultActions = _ref$mergeDefaultActi === void 0 ? true : _ref$mergeDefaultActi,
      _ref$pick = _ref.pick,
      pickedActions = _ref$pick === void 0 ? [] : _ref$pick,
      scope = _ref.scope,
      otherOptions = (0, _objectWithoutProperties2["default"])(_ref, ["url", "name", "pluralName", "actions", "mergeDefaultActions", "pick", "scope"]);
  // Merge passed actions with common defaults
  var resolvedActions = mergeDefaultActions ? (0, _util.mergeObjects)({}, _defaults.defaultActions, givenActions) : givenActions; // Eventually pick selected actions

  if (pickedActions.length) {
    resolvedActions = _util.pick.apply(void 0, [resolvedActions].concat((0, _toConsumableArray2["default"])(pickedActions)));
  }

  var types = (0, _types.createTypes)(resolvedActions, {
    resourceName: resourceName,
    resourcePluralName: resourcePluralName,
    scope: scope
  });
  var actions = (0, _actions2.createActions)(resolvedActions, _objectSpread({
    resourceName: resourceName,
    resourcePluralName: resourcePluralName,
    scope: scope,
    url: url
  }, otherOptions));
  var reducers = (0, _reducers2.createReducers)(resolvedActions, otherOptions);
  var rootReducer = (0, _reducers2.createRootReducer)(reducers, {
    resourceName: resourceName,
    scope: scope
  });
  return {
    actions: actions,
    reducers: rootReducer,
    // breaking change
    rootReducer: rootReducer,
    types: types
  };
}

function createResourceAction(_ref2) {
  var resourceName = _ref2.name,
      resourcePluralName = _ref2.pluralName,
      _ref2$method = _ref2.method,
      method = _ref2$method === void 0 ? 'GET' : _ref2$method,
      _ref2$isArray = _ref2.isArray,
      isArray = _ref2$isArray === void 0 ? false : _ref2$isArray,
      args = (0, _objectWithoutProperties2["default"])(_ref2, ["name", "pluralName", "method", "isArray"]);
  var actionId = method.toLowerCase();
  var scope = (0, _types.getTypesScope)(resourceName);
  var types = (0, _types.scopeTypes)((0, _types.createType)(actionId, {
    resourceName: resourceName,
    resourcePluralName: resourcePluralName,
    isArray: isArray
  }), scope);
  var actionName = (0, _actions2.getActionName)(actionId, {
    resourceName: resourceName,
    resourcePluralName: resourcePluralName
  });
  var actions = (0, _defineProperty2["default"])({}, actionName, (0, _actions2.createAction)(actionId, _objectSpread({
    scope: scope,
    isArray: isArray
  }, args)));
  var reducers = (0, _defineProperty2["default"])({}, actionId, (0, _reducers2.createReducer)(actionId, args));
  var rootReducer = (0, _reducers2.createRootReducer)(reducers, {
    resourceName: resourceName,
    scope: scope
  });
  return {
    actions: actions,
    reducers: reducers,
    // new API
    rootReducer: rootReducer,
    types: types
  };
}
//# sourceMappingURL=index.js.map