"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mergeReducers = exports.combineReducers = exports.reduceReducers = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var reduceReducers = function reduceReducers() {
  for (var _len = arguments.length, reducers = new Array(_len), _key = 0; _key < _len; _key++) {
    reducers[_key] = arguments[_key];
  }

  return function (state, action) {
    return reducers.reduce(function (stateSoFar, reducer) {
      return reducer(stateSoFar, action);
    }, state);
  };
};

exports.reduceReducers = reduceReducers;

var combineReducers = function combineReducers() {
  for (var _len2 = arguments.length, reducers = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    reducers[_key2] = arguments[_key2];
  }

  return function (state, action) {
    return reducers.reduce(function (stateSoFar, reducerMap) {
      return Object.keys(reducerMap).reduce(function (innerStateSoFar, key) {
        var reducer = reducerMap[key];
        var previousStateForKey = stateSoFar[key];
        var nextStateForKey = reducer(previousStateForKey, action);
        return _objectSpread(_objectSpread({}, innerStateSoFar), {}, (0, _defineProperty2["default"])({}, key, nextStateForKey));
      }, stateSoFar);
    }, state);
  };
};

exports.combineReducers = combineReducers;

var mergeReducers = function mergeReducers(baseReducer) {
  for (var _len3 = arguments.length, reducers = new Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
    reducers[_key3 - 1] = arguments[_key3];
  }

  var combinedReducers = combineReducers.apply(void 0, reducers);
  return function (state, action) {
    return combinedReducers(baseReducer(state, action), action);
  };
};

exports.mergeReducers = mergeReducers;
//# sourceMappingURL=helpers.js.map